﻿using System;
using System.ComponentModel;
using System.Linq.Expressions;
using System.Reflection;

namespace $rootnamespace$
{
    public class $safeitemname$ : INotifyPropertyChanged
    {

		#region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;
        protected void NotifyPropertyChanged<TProperty>(
			Expression<Func<$safeitemname$, TProperty>> propertyExpression)
        {
            MemberExpression memberExpression = propertyExpression.Body 
				as System.Linq.Expressions.MemberExpression;
            if (memberExpression == null || (memberExpression != null &&
                memberExpression.Member.MemberType != MemberTypes.Property))
            {
                throw new ArgumentException(
					"The specified expression does not represent a valid property");
            }
            OnPropertyChanged(memberExpression.Member.Name);
        }

        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler p = PropertyChanged;
            if (p != null)
            {
                p(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
    }
}
